--Ready up for Cata
--Author: Justin

--Configuration Variables
local partyMembers = 0
local unit
local achID
local isReady = false
local currentUnit
local unitName
local currentPlayer
local currentGroup
local tableOfPlayers = {}
local constructorTable = {}
local checkTheOverall = {}
local maxAch = 28

--frame
Meta = CreateFrame("Frame", "MetaFrame", UIParent)

--moving
Meta:SetScript("OnMouseDown", Meta.StartMoving)
--stop moving
Meta:SetScript("OnMouseUp", Meta.StopMovingOrSizing)

--Importent Event
Meta:RegisterEvent("INSPECT_ACHIEVEMENT_READY")

--Global Tables
currentAch = {}
theList = {}

--Check vs X
yesNo = {}
--Functions

--Making the Table
function Meta:makeTable()
	Meta:Show()
	unitName = "Everyone"
	currentUnit = "Everyone"
	Meta:personalTab() --Makes a tab that is either complete or not complete if all people are done 1, or if even 1 is not complete
	Meta:initCheck(0)
end

function Meta:initCheck(a)
	local loop = a
	if(loop<maxAch) then
		checkTheOverall[loop] = 0
		Meta:initCheck(loop+1)
	end
end

--Checking the Completionist Tab
function Meta:checkTable(a)
	unitName = "Everyone"
	currentUnit = "Everyone"
	local current = a
	if(current < currentAch[1]) then
		if(IsInGroup()) then
			if(checkTheOverall[current] >= partyMembers) then
				Meta:metaInTab(true,current)
			else
				Meta:metaInTab(false,current)
			end
		else
			if(checkTheOverall[current] == 1) then
				Meta:metaInTab(true,current)
			else
				Meta:metaInTab(false,current)
			end
		end
	Meta:checkTable(current+1)
	end
end

--Making a tab for each player
function Meta:personalTab()
	if not tableOfPlayers[currentUnit] then
		local tableOfAchieves = {}
		local trueFalses = {}
		tableOfAchieves[100] = trueFalses
		constructorTable[currentUnit] = tableOfAchieves
		local scan = CreateFrame( "Frame", currentUnit, InterfaceOptionsFramePanelContainer)
		tableOfPlayers[currentUnit] = scan
		tableOfPlayers[currentUnit]:Hide()
		tableOfPlayers[currentUnit].parent = meta.panel.name;
		tableOfPlayers[currentUnit].name = unitName
		InterfaceOptions_AddCategory(tableOfPlayers[currentUnit])
		Meta:nameInTab()
	else
		Meta:achieveInTab()
	end
end

--Putting the name into the personalTab frame
function Meta:nameInTab()
	local title = tableOfPlayers[currentUnit]:CreateFontString(currentUnit, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOP", 0, -5)
	title:SetText(unitName)
	Meta:achieveInTab()
end

--Putting the title of the achievement in the personal Tab
function Meta:achieveInTab()
	if not constructorTable[currentUnit][200] then
		local achTitle = tableOfPlayers[currentUnit]:CreateFontString(currentUnit.."1","ARTWORK","GameFontNormalLarge")
		constructorTable[currentUnit][200]=achTitle
		constructorTable[currentUnit][200]:SetPoint("TOP",tableOfPlayers[currentUnit],"TOP",0,-23)
		constructorTable[currentUnit][200]:SetText(currentAch[2])
	else
		constructorTable[currentUnit][200]:SetText(currentAch[2])
	end
end
--Putting the Achievements into the personalTab/overallTab frame
function Meta:metaInTab(b,c)
	if(constructorTable[currentUnit][c] == nil) then 
		local achieveText = tableOfPlayers[currentUnit]:CreateFontString("SPGaugeConfigPopupButtonTitle", "ARTWORK", "GameFontHighlight")
		constructorTable[currentUnit][c] = achieveText
		local dump1, idd = GetAchievementInfo(currentAch[3][c])
		constructorTable[currentUnit][c]:SetText(idd)
		if(c>(currentAch[1]/2)-1) then
			constructorTable[currentUnit][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPRIGHT", -120, (-30*(c-(currentAch[1]/2)-1))-90)
		else
			constructorTable[currentUnit][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPLEFT", 200, (-30*c)-60)
		end
	else
		local dump1, idd = GetAchievementInfo(currentAch[3][c])
		constructorTable[currentUnit][c]:SetText(idd)
		if(c>(currentAch[1]/2)-1) then
			constructorTable[currentUnit][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPRIGHT", -120, (-30*(c-(currentAch[1]/2)-1))-90)
		else
			constructorTable[currentUnit][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPLEFT", 200, (-30*c)-60)
		end
	end
	Meta:yesNo(b,c)
end

--Putting the Yes/No check or cross
function Meta:yesNo(b,c)
	if(constructorTable[currentUnit][100][c] == nil) then
		local boolean = tableOfPlayers[currentUnit]:CreateTexture(nil, "ARTWORK")
		constructorTable[currentUnit][100][c] = boolean
		constructorTable[currentUnit][100][c]:SetHeight(28)
		constructorTable[currentUnit][100][c]:SetWidth(28)
		if(c>(currentAch[1]/2)-1) then
			constructorTable[currentUnit][100][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPRIGHT", -90, (-30*(c-(currentAch[1]/2)-1))-90)
		else
			constructorTable[currentUnit][100][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPLEFT", 230, (-30*c)-60)
		end
	else
		if(c>(currentAch[1]/2)-1) then
			constructorTable[currentUnit][100][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPRIGHT", -90, (-30*(c-(currentAch[1]/2)-1))-90)
		else
			constructorTable[currentUnit][100][c]:SetPoint("RIGHT", tableOfPlayers[currentUnit], "TOPLEFT", 230, (-30*c)-60)
		end
	end
	if b then
		if(unitName ~= "Everyone") then
			checkTheOverall[c] = checkTheOverall[c]+1
		end
		constructorTable[currentUnit][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\check")
	else
		constructorTable[currentUnit][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\Cross")
	end
end

--Reseting the charts
function Meta:clearTables()
	Meta:clearAll(maxAch)
end

--Resets the Tab for a smooth transition
function Meta:clearAll(a)
	local current = a
	if(current >= 0) then
		if constructorTable[currentUnit] then
			if constructorTable[currentUnit][current] then
				constructorTable[currentUnit][current]:SetText("")
				constructorTable[currentUnit][100][current]:SetTexture(nil)
			end
		end
		Meta:clearAll(current-1)
	end
end


--Checking Party Members
function Meta:PartyCheckAchieve(a,b)
	currentPlayer = a
	currentGroup = b
	if(currentPlayer > 0) then
		Meta:SetFocus(currentGroup..currentPlayer)
	end
end

--Sets up the Comparison Unit for sweeping the selected meta achievement
function Meta:SetFocus(a)
	currentUnit = a
	unitName = GetUnitName(a)
	Meta:clearTables()
	print("current Unit: "..currentUnit)
	print("unit Name: "..unitName)
	SetAchievementComparisonUnit(currentUnit)
end

--Reports each achievement as a true/false for completion
function Meta:SweepAch(a)
	local current = a
	if(current < currentAch[1]) then
		local bool = GetAchievementComparisonInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
	Meta:SweepAch(current +1)
	end
end

--Called from Menu Options, Only used to initialize a self scan
function Meta:SweepSelfDummy()
	currentUnit = "player"
	unitName = GetUnitName("player")
	Meta:clearTables()
	Meta:personalTab()
	Meta:SweepSelf(0)
end

--Only needed to scan myself since WoW handles self differently
function Meta:SweepSelf(a)
	local current = a
	if(current < currentAch[1]) then
		local dump1, dump2, dump3, bool = GetAchievementInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
		Meta:SweepSelf(current+1)
	end
end
	
--The Scan Script
Meta:SetScript("OnEvent", 
	function(self, event, ...)
		print("Unit Name: "..unitName)
		if(UnitInRange(unitName)) then
			Meta:personalTab()
			Meta:SweepAch(0)
		end
			ClearAchievementComparisonUnit()
		if(currentPlayer > 1) then
			currentPlayer = currentPlayer -1
			Meta:SetFocus(currentGroup..currentPlayer)
		end
end)

